#include "timer1.h"
#include <avr/io.h>

enum { PERIOD = 100 };

void start_timer(void)
{
	TCCR1B=1;  							//clock timer without prescaler
	TCNT1=0;								//reset timer
	OCR1A=10;								//"Initial " value of output compare register A
	OCR1B=PERIOD;						
	TIFR&=~((1<<TOV1)|(1<<OCF1A)|(1<<OCF1B));			//delete any interrupt flags
	TIMSK|=((1<<OCIE1A)|(1<<OCIE1B));  	//start the timer - unlock used interrupts overflow and the output compare A
}

void stop_timer(void)
{
	TIMSK&=~((1<<TOIE1)|(1<<OCIE1A)|(1<<OCIE1B));  		//deactivate interrupts
	TIFR&=~((1<<TOV1)|(1<<OCF1A)|(1<<OCF1B));			//delete any interrupt flags
	TCCR1B=0;  								//stopping the clock
}

void set_timer_duty_cycle(uint8_t percent)
{
	if (percent > 0 && percent < 100)
		OCR1A = (uint32_t)PERIOD*percent/100;
}
